/*****************************/
/* 4章 常微分方程式の1段解法 */
/*****************************/

/* 本書の例題4.1,4.3に対するEuler法 */

#include<stdio.h>
#include<math.h>

#define M 4 // 検証する刻み幅の個数

/* 1階導関数 */
double f(double x, double y){
  return y;
}

/* 解析解 */
double y(double x){
  return M_E;
}

/* メイン関数 */
int main(void){
  int i, n, N;
  int num[M] = {4,7,10,13};
  double h, x, x0, xn, Y, erb;

  x0 = 0.0; // 始点
  xn = 1.0; // 終点

  printf("%7s: %18s: %8s: %8s\n",
		 "h", "Y(1)", "|Y(1)-e|", "e_N");
  for(i=0; i<47; i++){
	printf("-");
  }
  printf("\n");
  
  /* 各刻み幅に対して検証 */
  for(i=0; i<M; i++){

	N = pow(2,num[i]); // 分割数
	h = (xn - x0)/N;   // 刻み幅

	x = x0;  // 点の初期化
	Y = 1.0; // 初期条件

	/* オイラー法の計算 */
	for(n=0; n<N; n++){
	  Y += h*f(x,Y);
	  x += h;
	}

	/* 誤差限界 */
	erb = h*M_E*(M_E-1.0)/2.0;

	/* 計算結果の出力 */
	printf("2^{-%2d}: %.16f: %.2e: %.2e\n",
		   num[i], Y, fabs(Y-y(1)), erb);
	
  }

  return 0;
}
