/*****************************/
/* 4章 常微分方程式の1段解法 */
/*****************************/

/* 本書の例題4.7に対するEuler法（2階微分） */

#include<stdio.h>
#include<math.h>

#define M 4 // 検証する刻み幅の個数

/* 関数f1 = yの1階導関数 */
double f1(double x, double y, double z){
  return z;
}

/* 関数f2 = yの2階導関数*/
double f2(double x, double y, double z){
  return y;
}

/* 解析解 */
double y(double x){
  return pow(M_E, -x);
}

/* メイン関数 */
int main(void){
  int i, n, N;
  int num[M] = {4,7,10,13};
  double h, x, x0, xn, Y, Z, F1, F2;

  x0 = 0.0; // 始点
  xn = 1.0; // 終点

  printf("%7s: %18s: %8s\n",
		 "h", "Y(1)", "|Y(1)-e|");
  for(i=0; i<37; i++){
	printf("-");
  }
  printf("\n");
  
  /* 各刻み幅に対して検証 */
  for(i=0; i<M; i++){

	N = pow(2,num[i]); // 分割数
	h = (xn - x0)/N;   // 刻み幅

	x = x0;   // 点の初期化
	Y = 1.0;  // 初期条件 y(0)
	Z = -1.0; // 初期条件 z(0) = y'(0)

	/* オイラー法の計算 */
	for(n=0; n<N; n++){
	  F1 = f1(x,Y,Z);
	  F2 = f2(x,Y,Z);
	  Y += h*F1;
	  Z += h*F2;
	  x += h;
	}

	/* 計算結果の出力 */
	printf("2^{-%2d}: %.16f: %.2e\n",
		   num[i], Y, fabs(Y-y(1)));
	
  }

  return 0;
}
