/*****************************/
/* 4章 常微分方程式の1段解法 */
/*****************************/

/* 本書の例題4.5に対するRunge-Kutta法 */

#include<stdio.h>
#include<math.h>

#define M 7 // 検証する刻み幅の個数

/* 1階導関数 */
double f(double x, double y){
  return y;
}

/* 解析解 */
double y(double x){
  return M_E;
}

/* メイン関数 */
int main(void){
  int i, n, N;
  int num[M] = {1,2,3,4,5,6,7};
  double h, x, x0, xn, Y, k1, k2, k3, k4;

  x0 = 0.0; // 始点
  xn = 1.0; // 終点

  printf("%6s: %18s: %8s\n", "h", "Y(1)", "|Y(1)-e|");
  for(i=0; i<36; i++){
	printf("-");
  }
  printf("\n");
  
  /* 各刻み幅に対して検証 */
  for(i=0; i<M; i++){

	N = pow(2,num[i]); // 分割数
	h = (xn - x0)/N;   // 刻み幅

	x = x0;  // 点の初期化
	Y = 1.0; // 初期条件

	/* ルンゲ・クッタ法の計算 */
	for(n=0; n<N; n++){
	  k1 = f(x,Y);
	  x += h/2.0;
	  k2 = f(x,Y+h*k1/2.0);
	  k3 = f(x,Y+h*k2/2.0);
	  x += h/2.0;
	  k4 = f(x,Y+h*k3);
	  Y += h*(k1 + 2.0*k2 + 2.0*k3 + k4)/6.0;
	}

	/* 計算結果の出力 */
	printf("2^{-%d}: %.16f: %.2e\n",
		   num[i], Y, fabs(Y-y(1)));
	
  }

  return 0;
}
