# -*- coding: utf-8 -*-
"""************************"""
""" 4章 常微分方程式の1段解法 """
"""************************"""

""" 本書の例題4.1,4.3に対するEuler法 """ 

import math
M = 4 # 検証する刻み幅の個数

""" 1階導関数 """
def f (x, y) :
    return y
   
""" 解析解 """
def y (x) :
    return math.e

num = [4, 7, 10, 13]

x0 = 0.0 # 始点
xn = 1.0 # 終点

print("h: ".rjust(9)+"Y(1): ".rjust(20) + \
     "|Y(1)-e|: ".rjust(10)+"e_N".rjust(8))
print("-"*47)

""" 各刻み幅に対して検証 """
for i in range(M) :
    N = 2**num[i]  # 分割数
    h = (xn -x0)/N # 刻み幅

    x = x0  # 点の初期化
    Y = 1.0 # 初期条件

    """ オイラー法の計算 """
    for n in range(N) :
        Y += h*f(x,Y)
        x += h
    
    """ 誤差限界 """
    erb = h*math.e*(math.e-1.0)/2.0

    """ 計算結果の出力 """
    print("2^{-"+"{:2d}".format(num[i])+"}"+\
          ": {:.16f}: {:.2e}: {:.2e}".format(\
                         Y, abs(Y-y(1)), erb))
