# -*- coding: utf-8 -*-
"""************************"""
""" 4章 常微分方程式の1段解法 """
"""************************"""

""" 本書の例題4.7に対するEuler法（2階微分）""" 

import math
M = 4 # 検証する刻み幅の個数

""" 関数f1 = yの1階導関数 """
def f1 (x, y, z) :
    return z

""" 関数f2 = yの2階導関数 """
def f2 (x, y, z) :
    return y
   
""" 解析解 """
def y (x) :
    return math.e**-x

num = [4, 7, 10, 13]

x0 = 0.0 # 始点
xn = 1.0 # 終点

print("h: ".rjust(9)+"Y(1): ".rjust(20) + \
     "|Y(1)-e| ".rjust(9))
print("-"*37)

""" 各刻み幅に対して検証 """
for i in range(M) :
    N = 2**num[i]  # 分割数
    h = (xn -x0)/N # 刻み幅

    x = x0  # 点の初期化
    Y = 1.0 # 初期条件
    Z =-1.0 # 初期条件 z(0) = y'(0)

    """ オイラー法の計算 """
    for n in range(N) :
        F1 = f1(x,Y,Z)
        F2 = f2(x,Y,Z)
        Y += h*F1
        Z += h*F2
        x += h

    """ 計算結果の出力 """
    print("2^{-"+"{:2d}".format(num[i])+"}"+\
          ": {:.16f}: {:.2e}".format(\
                         Y, abs(Y-y(1))))
