# -*- coding: utf-8 -*-
"""************************"""
""" 7章 常微分方程式の多段解法 """
"""************************"""

""" 本書の例題7.3に対するLeapfrog法（中点公式） """ 

import math

""" 1階導関数 """
def f (x, y) :
    return - y
   
""" 解析解 """
def y (x) :
    return math.e**(-x)

Y = [0 for i in range(101)] # 分割数+1 の領域を確保

x0 = 0.0 # 始点
xn = 10.0 # 終点

print("h: ".rjust(5)+"Y(x): ".rjust(24) + \
     "y(x): ".rjust(24) + "|Y(x)-y(x)|".rjust(15))
print("-"*68)

N = 100         # 分割数
h = (xn - x0)/N # 刻み幅

x = x0     # 点の初期化
Y[0] = 1.0 # 初期条件

""" ホイン法による予備計算（A:=-1） """
Y[1] = (1.0 - h + h*h/2.0)*Y[0]

""" 中点公式の計算 """
for n in range(1,N) :
    Y[n+1] = Y[n-1] - 2.0*h*Y[n]

""" 計算結果の出力 """
for n in range(N+1) :
    print("{:.1f}:\t {:.16f}:\t {:.16f}:\t {:.2e}"\
            .format(x,Y[n],y(x),abs(Y[n]-y(x))))
    x += h
