# -*- coding: utf-8 -*-
"""************************"""
""" 4章 常微分方程式の1段解法 """
"""************************"""

""" 本書の例題4.5に対するRunge-Kutta法 """ 

import math
M = 7 # 検証する刻み幅の個数

""" 1階導関数 """
def f (x, y) :
    return y
   
""" 解析解 """
def y (x) :
    return math.e

num = range(1,8)
x0 = 0.0 # 始点
xn = 1.0 # 終点

print("h: ".rjust(8)+"Y(1): ".rjust(20) + \
     "|Y(1)-e|".rjust(8))
print("-"*36)

""" 各刻み幅に対して検証 """
for i in range(M) :
    N = 2**num[i]  # 分割数
    h = (xn -x0)/N # 刻み幅

    x = x0  # 点の初期化
    Y = 1.0 # 初期条件

    """ ルンゲ・クッタ法の計算 """
    for n in range(N) :
        k1 = f(x,Y) 
        x += h/2.0
        k2 = f(x,Y+h*k1/2.0)
        k3 = f(x,Y+h*k2/2.0)
        x += h/2.0
        k4 = f(x,Y+h*k3)
        Y += h*(k1 + 2.0*k2 + 2.0*k3 + k4)/6.0
    
    """ 計算結果の出力 """
    print("2^{-"+"{:1d}".format(num[i])+"}"+\
          ": {:.16f}: {:.2e}".format(\
                         Y, abs(Y-y(1))))
